/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.entschaedigung.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class EntschaedigungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

  protected final de.ivu.elect.business.entschaedigung.entity.AuszahlungTK auszahlungTK;
    public de.ivu.elect.business.entschaedigung.entity.AuszahlungTK getAuszahlungTK(){
      return auszahlungTK;
    }
  protected final de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartTK entschaedigungsartTK;
    public de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartTK getEntschaedigungsartTK(){
      return entschaedigungsartTK;
    }
  protected final de.ivu.elect.business.person.entity.PersonendatenTK personendatenTK;
    public de.ivu.elect.business.person.entity.PersonendatenTK getPersonendatenTK(){
      return personendatenTK;
    }

  public EntschaedigungTK(
  de.ivu.elect.business.entschaedigung.entity.AuszahlungTK auszahlungTK
,   de.ivu.elect.business.entschaedigung.entity.EntschaedigungsartTK entschaedigungsartTK
,   de.ivu.elect.business.person.entity.PersonendatenTK personendatenTK
  ) {
    super();


        this.auszahlungTK = auszahlungTK;
      this.entschaedigungsartTK = entschaedigungsartTK;
      this.personendatenTK = personendatenTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
        
                    result = result + ((auszahlungTK == null) ? 0 : auszahlungTK.hashCode());
                    result = result + ((entschaedigungsartTK == null) ? 0 : entschaedigungsartTK.hashCode());
                    result = result + ((personendatenTK == null) ? 0 : personendatenTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof EntschaedigungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        EntschaedigungTK other = (EntschaedigungTK) obj;

        
                if (auszahlungTK == null) {
          if (other.auszahlungTK != null) {
            return false;
          }
        } else if (!auszahlungTK.equals(other.auszahlungTK)) {
          return false;
        }
                if (entschaedigungsartTK == null) {
          if (other.entschaedigungsartTK != null) {
            return false;
          }
        } else if (!entschaedigungsartTK.equals(other.entschaedigungsartTK)) {
          return false;
        }
                if (personendatenTK == null) {
          if (other.personendatenTK != null) {
            return false;
          }
        } else if (!personendatenTK.equals(other.personendatenTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return EntschaedigungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(auszahlungTK.getAllEntityFieldValues());
    result.addAll(entschaedigungsartTK.getAllEntityFieldValues());
    result.addAll(personendatenTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            return java.util.Collections.emptyList();
      }


            @Override
            public String toString() {
            return "EntschaedigungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                                    +"auszahlungTK="+auszahlungTK
                            +", entschaedigungsartTK="+entschaedigungsartTK
                            +", personendatenTK="+personendatenTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                                  +  toStringLokalisiert(auszahlungTK, messages)
                          + ", " +  toStringLokalisiert(entschaedigungsartTK, messages)
                          + ", " +  toStringLokalisiert(personendatenTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Entschaedigung> java.util.Map<EntschaedigungTK, E> mappeEntschaedigungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Entschaedigung::getEntschaedigungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Entschaedigung, EntschaedigungTK> getEntschaedigungToTKFunction() {
                return Entschaedigung::getEntschaedigungTK;
                }

}
